
<template>
  <app-user-page :breadcrumbs="breadcrumbs">
    <CCard>
      <CCardBody>
        <item-search-form
          :default-condition="condition"
          :loading="loading"
          @submit="onSearch"
        />

        <div class="main-control">
          <app-sort
            :value="sortId"
            :list="SORT_LIST"
            :name="'ソート'"
            :placeholder="'選んでください'"
            :disabled="loading"
            @sort-change="onSort"
          />
          <app-pagination
            :total="total"
            :page-size="limit"
            :current-page="page"
            :item-name="'商品'"
            :disabled="loading"
            @page-change="onPageChange"
            @page-size-change="onPageSizeChange"
          />
        </div>

        <item-table
          :data="data"
          :loading="loading"
          @detail="onShowDetail"
        />

        <div class="main-control">
          <app-sort
            :value="sortId"
            :list="SORT_LIST"
            :name="'ソート'"
            :placeholder="'選んでください'"
            :disabled="loading"
            @sort-change="onSort"
          />
          <app-pagination
            :total="total"
            :page-size="limit"
            :current-page="page"
            :item-name="'商品'"
            :disabled="loading"
            @page-change="onPageChange"
            @page-size-change="onPageSizeChange"
          />
        </div>
      </CCardBody>

      <CCardFooter>
        <div class="card-footer-actions">
          <CButton
            color="secondary"
            to="/boxes"
          >
            <font-awesome-icon :icon="['fas', 'arrow-left']" />
            箱一覧へ
          </CButton>
          <a
            target="_blank"
            rel="noopener noreferrer"
            href="#"
            class="btn btn-secondary"
          >
            <font-awesome-icon :icon="['fas', 'download']" />
            PDFダウンロード
          </a>
        </div>
      </CCardFooter>
    </CCard>

    <item-detail-modal
      :id="selectedId"
      ref="itemDetailModal"
    />
  </app-user-page>
</template>

<script>
import AppPagination from '~/components/atoms/AppPagination'
import AppSort from '~/components/atoms/AppSort'
import ItemSearchForm from '~/components/organisms/items/ItemSearchForm'
import ItemTable from '~/components/organisms/items/ItemTable'
import ItemDetailModal from '~/components/organisms/items/ItemDetailModal'

import AsyncLoading from '~/mixins/do-async-loading'
import ConditionHandler from '~/mixins/condition'
import SearchFormHandler from '~/mixins/search-form'
import Paginator from '~/mixins/paginator'
import SortHandler from '~/mixins/sort'

const SORT_LIST = [
  {
    id: 1,
    label: 'ID ASC',
    sort: 'id',
    sortType: 1
  },
  {
    id: 2,
    label: 'ID DESC',
    sort: 'id',
    sortType: 0
  }
]

export default {
  middleware: ['auth'],

  layout: 'user',

  components: {
    ItemSearchForm,
    ItemTable,
    AppPagination,
    AppSort,
    ItemDetailModal
  },

  mixins: [
    AsyncLoading,
    ConditionHandler,
    SearchFormHandler,
    Paginator,
    SortHandler
  ],

  data () {
    return {
      resourceTypeName: 'item',
      total: 0,
      data: [],
      selectedId: null,
      SORT_LIST,
      sortId: null
    }
  },

  computed: {
    /**
     * Generate breadcrumbs
     *
     * @return {array} List breadcrumbs
     */
    breadcrumbs () {
      return [
        {
          text: 'ホーム',
          to: '/'
        },
        {
          text: '商品一覧'
        }
      ]
    },

    /**
     * Get query
     */
    query () {
      return Object.assign({}, this.paginationQuery, this.conditionQuery, {
        sort: this.sort,
        sortType: this.sortType
      })
    }
  },

  mounted () {
    this.refresh()
  },

  methods: {
    /**
     * Call API get item list by condition search
     * Show data on table result
     *
     * @return {Object} API response for error handle
     */
    async fetch () {
      const res = await this.$dam.getProductList(this.query)

      if (Array.isArray(res.data) && res.data.length) {
        this.total = res.meta.total
        this.data = res.data
      }

      return res
    },

    /**
     * Show detail
     *
     * @param {Number} id - Item Id
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.itemDetailModal.open()
    },

    /**
     * Set select id
     *
     * @param {Number} id - group id
     */
    setSelectedId (id) {
      this.selectedId = id
    }
  }
}
</script>
